
tuomas@13740: /***************************************************************************************************
tuomas@13740:  Header file:
tuomas@13740:  LVUVCPublic.h
tuomas@13740: 
tuomas@13740:  Description:
tuomas@13740: 
tuomas@13740:  The Logitech UVC Driver Public Property Sets are a collection of property sets designed for use by
tuomas@13740:  third party application developers. This include file contains the necessary interface definitions
tuomas@13740:  to use these property sets.
tuomas@13740: 
tuomas@13740:  Please refer to the document "Logitech UVC Driver Public Property Sets: Specification" available
tuomas@13740:  from http://www.quickcamteam.net/ for details.
tuomas@13740: 
tuomas@13740:  Version: 1.0
tuomas@13740: 
tuomas@13740:  Copyright (c) 2009 Logitech,  All Rights Reserved
tuomas@13740: ***************************************************************************************************/
tuomas@13740: 
tuomas@13740: #ifndef LVUVCPUBLIC_H
tuomas@13740: #define LVUVCPUBLIC_H
tuomas@13740: 
tuomas@13740: 
tuomas@13740: /*******************************************************************************
tuomas@13740:  * GUIDS
tuomas@13740:  ******************************************************************************/
tuomas@13740: 
tuomas@13740: // {CAAE4966-272C-44a9-B792-71953F89DB2B}
tuomas@13740: #define STATIC_PROPSETID_LOGITECH_PUBLIC1 \
tuomas@13740: 	0xCAAE4966, 0x272C, 0x44A9, 0xB7, 0x92, 0x71, 0x95, 0x3F, 0x89, 0xDB, 0x2B
tuomas@13740: DEFINE_GUIDSTRUCT("CAAE4966-272C-44a9-B792-71953F89DB2B", PROPSETID_LOGITECH_PUBLIC1);
tuomas@13740: #define PROPSETID_LOGITECH_PUBLIC1 DEFINE_GUIDNAMED(PROPSETID_LOGITECH_PUBLIC1)
tuomas@13740: 
tuomas@13740: 
tuomas@13740: 
tuomas@13740: /*******************************************************************************
tuomas@13740:  * ENUMERATIONS AND CONSTANTS
tuomas@13740:  ******************************************************************************/
tuomas@13740: 
tuomas@13740: typedef enum _KSPROPERTY_LP1_PROPERTY {
tuomas@13740: 	KSPROPERTY_LP1_VERSION,
tuomas@13740: 	KSPROPERTY_LP1_DIGITAL_PAN,
tuomas@13740: 	KSPROPERTY_LP1_DIGITAL_TILT,
tuomas@13740: 	KSPROPERTY_LP1_DIGITAL_ZOOM,
tuomas@13740: 	KSPROPERTY_LP1_DIGITAL_PANTILTZOOM,
tuomas@13740: 	KSPROPERTY_LP1_EXPOSURE_TIME,
tuomas@13740: 	KSPROPERTY_LP1_FACE_TRACKING,
tuomas@13740: 	KSPROPERTY_LP1_LED,
tuomas@13740: 	KSPROPERTY_LP1_FINDFACE,
tuomas@13740: 
tuomas@13740: 	KSPROPERTY_LP1_LAST = KSPROPERTY_LP1_FINDFACE
tuomas@13740: 
tuomas@13740: } KSPROPERTY_LP1_PROPERTY;
tuomas@13740: 
tuomas@13740: 
tuomas@13740: typedef enum _LVUVC_LP1_FACE_TRACKING_MODE {
tuomas@13740: 	LVUVC_LP1_FACE_TRACKING_MODE_OFF,
tuomas@13740: 	LVUVC_LP1_FACE_TRACKING_MODE_SINGLE,
tuomas@13740: 	LVUVC_LP1_FACE_TRACKING_MODE_MULTIPLE,
tuomas@13740: } LVUVC_LP1_FACE_TRACKING_MODE;
tuomas@13740: 
tuomas@13740: 
tuomas@13740: typedef enum _LVUVC_LP1_LED_MODE {
tuomas@13740: 	LVUVC_LP1_LED_MODE_OFF,
tuomas@13740: 	LVUVC_LP1_LED_MODE_ON,
tuomas@13740: 	LVUVC_LP1_LED_MODE_BLINKING,
tuomas@13740: 	LVUVC_LP1_LED_MODE_AUTO,
tuomas@13740: } LVUVC_LP1_LED_MODE;
tuomas@13740: 
tuomas@13740: 
tuomas@13740: typedef enum _LVUVC_LP1_FINDFACE_MODE {
tuomas@13740: 	LVUVC_LP1_FINDFACE_MODE_NO_CHANGE,
tuomas@13740: 	LVUVC_LP1_FINDFACE_MODE_OFF,
tuomas@13740: 	LVUVC_LP1_FINDFACE_MODE_ON,
tuomas@13740: } LVUVC_LP1_FINDFACE_MODE;
tuomas@13740: 
tuomas@13740: 
tuomas@13740: typedef enum _LVUVC_LP1_FINDFACE_RESET {
tuomas@13740: 	LVUVC_LP1_FINDFACE_RESET_NONE,
tuomas@13740: 	LVUVC_LP1_FINDFACE_RESET_DEFAULT,
tuomas@13740: 	LVUVC_LP1_FINDFACE_RESET_FACE,
tuomas@13740: } LVUVC_LP1_FINDFACE_RESET;
tuomas@13740: 
tuomas@13740: 
tuomas@13740: 
tuomas@13740: /*******************************************************************************
tuomas@13740:  * STRUCTURES
tuomas@13740:  ******************************************************************************/
tuomas@13740: 
tuomas@13740: typedef struct _KSPROPERTY_LP1_HEADER {
tuomas@13740: 	ULONG					ulFlags;
tuomas@13740: 	ULONG					ulReserved1;
tuomas@13740: 	ULONG					ulReserved2;
tuomas@13740: } KSPROPERTY_LP1_HEADER, *PKSPROPERTY_LP1_HEADER;
tuomas@13740: 
tuomas@13740: typedef struct _KSPROPERTY_LP1_VERSION_S {
tuomas@13740: 	KSPROPERTY_LP1_HEADER	Header;
tuomas@13740: 	USHORT					usMajor;
tuomas@13740: 	USHORT					usMinor;
tuomas@13740: } KSPROPERTY_LP1_VERSION_S, *PKSPROPERTY_LP1_VERSION_S;
tuomas@13740: 
tuomas@13740: typedef struct _KSPROPERTY_LP1_DIGITAL_PAN_S {
tuomas@13740: 	KSPROPERTY_LP1_HEADER	Header;
tuomas@13740: 	LONG					lPan;
tuomas@13740: } KSPROPERTY_LP1_DIGITAL_PAN_S, *PKSPROPERTY_LP1_DIGITAL_PAN_S;
tuomas@13740: 
tuomas@13740: typedef struct _KSPROPERTY_LP1_DIGITAL_TILT_S {
tuomas@13740: 	KSPROPERTY_LP1_HEADER	Header;
tuomas@13740: 	LONG					lTilt;
tuomas@13740: } KSPROPERTY_LP1_DIGITAL_TILT_S, *PKSPROPERTY_LP1_DIGITAL_TILT_S;
tuomas@13740: 
tuomas@13740: typedef struct _KSPROPERTY_LP1_DIGITAL_ZOOM_S {
tuomas@13740: 	KSPROPERTY_LP1_HEADER	Header;
tuomas@13740: 	ULONG					ulZoom;
tuomas@13740: } KSPROPERTY_LP1_DIGITAL_ZOOM_S, *PKSPROPERTY_LP1_DIGITAL_ZOOM_S;
tuomas@13740: 
tuomas@13740: typedef struct _KSPROPERTY_LP1_DIGITAL_PANTILTZOOM_S {
tuomas@13740: 	KSPROPERTY_LP1_HEADER	Header;
tuomas@13740: 	LONG					lPan;
tuomas@13740: 	LONG					lTilt;
tuomas@13740: 	ULONG					ulZoom;
tuomas@13740: } KSPROPERTY_LP1_DIGITAL_PANTILTZOOM_S, *PKSPROPERTY_LP1_DIGITAL_PANTILTZOOM_S;
tuomas@13740: 
tuomas@13740: typedef struct _KSPROPERTY_LP1_EXPOSURE_TIME_S {
tuomas@13740: 	KSPROPERTY_LP1_HEADER	Header;
tuomas@13740: 	ULONG					ulExposureTime;
tuomas@13740: } KSPROPERTY_LP1_EXPOSURE_TIME_S, *PKSPROPERTY_LP1_EXPOSURE_TIME_S;
tuomas@13740: 
tuomas@13740: typedef struct _KSPROPERTY_LP1_FACE_TRACKING_S {
tuomas@13740: 	KSPROPERTY_LP1_HEADER	Header;
tuomas@13740: 	ULONG					ulMode;			// See LVUVC_LP1_FACE_TRACKING_MODE
tuomas@13740: } KSPROPERTY_LP1_FACE_TRACKING_S, *PKSPROPERTY_LP1_FACE_TRACKING_S;
tuomas@13740: 
tuomas@13740: typedef struct _KSPROPERTY_LP1_LED_S {
tuomas@13740: 	KSPROPERTY_LP1_HEADER	Header;
tuomas@13740: 	ULONG					ulMode;			// See LVUVC_LP1_LED_MODE
tuomas@13740: 	ULONG					ulFrequency;
tuomas@13740: } KSPROPERTY_LP1_LED_S, *PKSPROPERTY_LP1_LED_S;
tuomas@13740: 
tuomas@13740: typedef struct _KSPROPERTY_LP1_FINDFACE_S {
tuomas@13740: 	KSPROPERTY_LP1_HEADER	Header;
tuomas@13740: 	ULONG					ulMode;			// See LVUVC_LP1_FINDFACE_MODE
tuomas@13740: 	ULONG					ulReset;		// See LVUVC_LP1_FINDFACE_RESET
tuomas@13740: } KSPROPERTY_LP1_FINDFACE_S, *PKSPROPERTY_LP1_FINDFACE_S;
tuomas@13740: 
tuomas@13740: 
tuomas@13740: #endif // #ifndef LVUVCPUBLIC_H




