/* 
    Webcam Lab

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    (C) 2005 Jason Hunt
    nulluser@gmail.com
    
    file: display.cpp
*/


#include "core.h"

//#include <dshow.h>


unsigned int display_x  =  640;                     // Sample ares size in pixels
unsigned int display_y  =  480;

static char text_area[text_y_size][text_x_size];  // the data for textr display
        

bool display_fps = false;

/* Display the text area */
void display_text( void )
{
    // Clear the old text area
    Rectangle(main_dc, 0, display_y, display_x, display_y + text_area_height+2);
        
       // draw text lines
    for (unsigned int r = 0; r < text_y_size; r++)
        TextOut(main_dc, 2, r * font_y_size + display_y+1, text_area[r], strlen(text_area[r]));

    if (main_win != NULL)
        InvalidateRect (main_win, NULL, FALSE);
}
/* End if display_text */


/* Called when windows is resized to modify the display area size */
void display_resize(unsigned int new_x, unsigned int new_y)
{
    display_x = new_x; 
    display_y = new_y - text_area_height - 2;
    
    display_text();
}
/* End of display_resize */


/* Show the text buffer on the screen */
void display(void)
{
    if (!camera_buffer) return;

    
    // copy camera buffer
    // We are using a negative size to mirron the image up and down


    if (fast_capture)
    {
        StretchDIBits(main_dc, 
                      0, 0, display_x, display_y, 
                      0, camera_y_size-1, camera_x_size, -camera_y_size,               
                      camera_buffer, &camera_buffer_info, 
                      DIB_RGB_COLORS, SRCCOPY);             
    } else
    {
        StretchDIBits(main_dc, 
                      0, 0, display_x, display_y, 
                      0, 0, camera_x_size, camera_y_size,               
                      camera_buffer, &camera_buffer_info, 
                      DIB_RGB_COLORS, SRCCOPY);             

    }                                           

    if (display_fps)
    {
        // Display textu information
        char b[400];
        sprintf(b, "FPS: %3d", fps);
        TextOut(main_dc, 2, 2, b, strlen(b));
    }

    display_text();

    ValidateRect(main_win, NULL);
}
/* End of display_text_area */


/* Reset the text area */
void clear_text_area( void )
{
    memset(text_area, 0x00, text_y_size * text_x_size);
}
/* End fo clear text area */


/* Adds a line to the text buffer */
void add_line(char *line)
{    
    static unsigned int text_y = 0; 

    // Scrool the display up
    if (text_y == text_y_size)
    {
        for (int i = 1; i < text_y_size; i++)
            memcpy(text_area[i-1], text_area[i], text_x_size);
    }
    else
        text_y ++;
    // Copy the string
    unsigned int line_len = strlen(line);

    strncpy(text_area[text_y - 1], line, text_x_size);

    console(line);
    console("\n");

    display_text();
}
/* End of add line */


/* Make a color */
color_type get_color(unsigned char r, unsigned char g, unsigned char b)
{
    color_type t;
    
    t.r = r; t.b = b; t.g = g;
    
    return(t);
}
/* End of get_color */



















