/* 
    Webcam Lab

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    (C) 2005 Jason Hunt
    nulluser@gmail.com
   
    file: display.h
*/

#ifndef DISPLAY_H
#define DISPLAY_H

#include <windows.h>
#include "types.h"

#define MAX_SAMPLES 64

typedef struct sample_type
{
    char name[32];
    unsigned char num;
    float value;    
};


void display(void);             // Display frame buffer and text into
void create_buffer(void);       // Called during program start in init
void destroy_buffer( void );    // Called during program end to deinit
void clear_text_area( void );   // Reset text area to white
void add_line (char *);         // Add a line of text
void display_text(void);        // Display text box
void copy_bitmap(HBITMAP h);
void display_resize(unsigned int new_x, unsigned int new_y);



color_type get_color(unsigned char r, unsigned char g, unsigned char b);

#define text_x_size 80           // Number of text colums
#define text_y_size 5            // Nuumber of text rows

#define font_x_size 8            // Font size in pixels
#define font_y_size 16           // Font y_size in pixels

#define text_area_height  (text_y_size*font_y_size)  // Size of text area
#define text_area_width  (text_x_size*font_x_size) 

extern unsigned int display_x;
extern unsigned int display_y;

extern bool display_fps;

#endif



