/* 
    Webcam Lab

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    (C) 2005 Jason Hunt
    nulluser@gmail.com
   
    file: process.h
*/

#ifndef PROCESS_H
#define PROCESS_H
#define NUM_BACK_BUFFERS 25


void process_frame( void );
void process_start ( void );
void process_stop ( void );
void show_filters( void );
void clear_buffers( void );

void swap(color_type *&a, color_type *&b);

extern color_type *save_frame;
extern color_type *temp_frame;
extern color_type *last_frame;

extern color_type *back_buffers[NUM_BACK_BUFFERS];

extern bool d_frame;
extern bool filter_gauss;
extern bool filter_rc;
extern bool filter_sharpness;
extern bool filter_edgefast;
extern bool filter_laplace;
extern bool filter_sobel;
extern bool filter_emboss;
extern bool filter_erode;
extern bool filter_threshold;
extern bool filter_tracking;
extern bool filter_speed;



extern bool filter_average;

extern bool filter_reduceedge;

extern bool filter_comboedge;

extern double threshold_1;
extern double threshold_2;

extern bool fast_capture;

extern bool filter_canny;

#endif
