/* 
    Webcam Lab

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    (C) 2005 Jason Hunt
    nulluser@gmail.com
    
    file: utility.cpp
*/


#include "core.h"



/* Wrtte formatted data to the debugging console */
void console(char *fmt, ... )
{
    static HANDLE h_console = INVALID_HANDLE_VALUE;

    if (h_console == INVALID_HANDLE_VALUE)
    {
        AllocConsole();
        h_console =  GetStdHandle(STD_OUTPUT_HANDLE);
    }
   
    const unsigned int max = 1024;

    va_list args;
    char text[max];

    va_start(args, fmt);
    vsnprintf(text, max, fmt, args);
    va_end(args);    
    
    DWORD out = 0;
   
    WriteConsole(h_console, text, strlen(text), &out, NULL);
    writelog(text);
}
/* End of write_console */


/* adds an item to the log file */
void addlog(char *s)
{
    SYSTEMTIME st;
    GetLocalTime(&st); 

    FILE *f = fopen("log.txt", "at");   

    if (!f)
    {
        add_line("Unable to create log file");
        return;
    }
    
    fprintf(f, "[%d/%d/%d - %d:%d:%d%] %s",st.wMonth, st.wDay, st.wYear, 
                                             st.wHour, st.wMinute, st.wSecond, s);

    fclose(f);  // this is slow, but we want whatever data we have if the client crashes
}
/* end of log */




/* Wrtte formatted data to the debugging console */
void writelog(char *fmt, ... )
{
    static HANDLE h_console = INVALID_HANDLE_VALUE;

    if (h_console == INVALID_HANDLE_VALUE)
    {
        AllocConsole();
        h_console =  GetStdHandle(STD_OUTPUT_HANDLE);
    }
   
    const unsigned int max = 1024;

    va_list args;
    char text[max];

    va_start(args, fmt);
    vsnprintf(text, max, fmt, args);
    va_end(args);    
    
    DWORD out = 0;
   
    addlog(text);
}
/* End of write_console */


void get_time_str(char *st1)
{

    SYSTEMTIME st;
    GetLocalTime(&st); 


    
    sprintf(st1, "%02d %02d %02d - %02d %02d %02d",st.wMonth, st.wDay, st.wYear, 
                                             st.wHour, st.wMinute, st.wSecond);

}




/* adds an item to the log file */
void addrecord(char *s)
{
    SYSTEMTIME st;
    GetLocalTime(&st); 

    FILE *f = fopen("images\\record.csv", "at");   

    if (!f)
    {
        add_line("Unable to create log file");
        return;
    }

    fprintf(f, "\"%d/%d/%d\",\"%d:%d:%d%\"%s\n",st.wMonth, st.wDay, st.wYear, 
                                                 st.wHour, st.wMinute, st.wSecond, s);

    fclose(f);  // this is slow, but we want whatever data we have if the client crashes
  
}
/* end of log */









