/* 
    Webcam Lab

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    (C) 2005 Jason Hunt
    nulluser@gmail.com
   
    file: window.cpp
*/


#include "core.h"


HWND main_win = NULL;              // Keep track of the main window
HDC main_dc = NULL;

static char c_name[] = program_name ;     // Setclass name


/* Create the main window */
int setup_window(HINSTANCE hThisInstance, int nCmdShow)
{
    WNDCLASSEX wincl;  

    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = c_name;
    wincl.lpfnWndProc = WinProc;      
    wincl.style = CS_DBLCLKS | CS_OWNDC;         
    wincl.cbSize = sizeof (WNDCLASSEX);

    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;               
    wincl.cbClsExtra = 0;                    
    wincl.cbWndExtra = 0;                    
    wincl.hbrBackground = (HBRUSH)(COLOR_WINDOW+1); 

    if (!RegisterClassEx (&wincl)) return(1);

    HWND hwnd = CreateWindowEx (WS_EX_OVERLAPPEDWINDOW, c_name,
                               program_name ,  
                               WS_OVERLAPPEDWINDOW  ,//WS_SYSMENU,
                               //WS_OVERLAPPEDWINDOW| WS_MINIMIZEBOX ,// | WS_MAXIMIZE, 

                               150, 150,   // pos
                               display_x + 7, // size
                               display_y + 27 + text_area_height+2,
                               HWND_DESKTOP, NULL,
                               hThisInstance, NULL);

    if (!hwnd) return(1); // Make sure it was made

    main_win = hwnd; // Aave the handle

    main_dc = GetDC(main_win);

    ShowWindow (hwnd, nCmdShow); // Display the window

    return(0);
}
/* End of setup window */


/* Shut down window */
void destroy_window( void )
{
    return;   
}
/* End of destroy_window */


/* Resize the windows to the size in the parmeters */
void resize_window(void)
{    
    int x_size = display_x + 7;
    int y_size = display_y + 27 + text_area_height+2;
    
    WINDOWPLACEMENT p;                      // Hlds window data

    p.length = sizeof(WINDOWPLACEMENT);     // Setup struct
    GetWindowPlacement(main_win, &p);      // Get window information
        
    p.rcNormalPosition.right = p.rcNormalPosition.left + x_size;
    p.rcNormalPosition.bottom= p.rcNormalPosition.top + y_size;
        
    SetWindowPlacement(main_win, &p);

//    create_buffer();       

  //  main_dc = GetDC(main_win);
    
    display();

    display_text();
}
/* End of resize window */






